| Version: 3.3.1

Public Member Functions | List of all members
wxPropertyGridEvent Class Reference
Class List by Category » wxPropertyGrid | Class List by Category » Events

`#include <wx/propgrid/propgrid.h>`

Inheritance diagram for wxPropertyGridEvent:
[legend]

## Detailed Description

A property grid event holds information about events associated with wxPropertyGrid objects.

To process input from a property grid control, use these event handler macros to direct input to member functions that take a wxPropertyGridEvent argument.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxPropertyGridEvent& event)

Event macros for events emitted by this class:

- EVT_PG_SELECTED (id, func):
  Respond to `wxEVT_PG_SELECTED` event, generated when a property selection has been changed, either by user action or by indirect program function. For instance, collapsing a parent property programmatically causes any selected child property to become unselected, and may therefore cause this event to be generated.
- EVT_PG_CHANGED(id, func):
  Respond to `wxEVT_PG_CHANGED` event, generated when property value has been changed by the user.
- EVT_PG_CHANGING(id, func):
  Respond to `wxEVT_PG_CHANGING` event, generated when property value is about to be changed by user. Use wxPropertyGridEvent::GetValue() to take a peek at the pending value, and wxPropertyGridEvent::Veto() to prevent change from taking place, if necessary.
- EVT_PG_HIGHLIGHTED(id, func):
  Respond to `wxEVT_PG_HIGHLIGHTED` event, which occurs when mouse moves over a property. Event's property is nullptr if hovered area does not belong to any property.
- EVT_PG_RIGHT_CLICK(id, func):
  Respond to `wxEVT_PG_RIGHT_CLICK` event, which occurs when property is clicked on with right mouse button.
- EVT_PG_DOUBLE_CLICK(id, func):
  Respond to `wxEVT_PG_DOUBLE_CLICK` event, which occurs when property is double-clicked on with left mouse button.
- EVT_PG_ITEM_COLLAPSED(id, func):
  Respond to `wxEVT_PG_ITEM_COLLAPSED` event, generated when user collapses a property or category.
- EVT_PG_ITEM_EXPANDED(id, func):
  Respond to `wxEVT_PG_ITEM_EXPANDED` event, generated when user expands a property or category.
- EVT_PG_LABEL_EDIT_BEGIN(id, func):
  Respond to `wxEVT_PG_LABEL_EDIT_BEGIN` event, generated when user is about to begin editing a property label. You can veto this event to prevent the action.
- EVT_PG_LABEL_EDIT_ENDING(id, func):
  Respond to `wxEVT_PG_LABEL_EDIT_ENDING` event, generated when user is about to end editing of a property label. You can veto this event to prevent the action.
- EVT_PG_COL_BEGIN_DRAG(id, func):
  Respond to `wxEVT_PG_COL_BEGIN_DRAG` event, generated when user starts resizing a column - can be vetoed.
- EVT_PG_COL_DRAGGING, (id, func):
  Respond to `wxEVT_PG_COL_DRAGGING`, event, generated when a column resize by user is in progress. This event is also generated when user double-clicks the splitter in order to recenter it.
- EVT_PG_COL_END_DRAG(id, func):
  Respond to `wxEVT_PG_COL_END_DRAG` event, generated after column resize by user has finished.

##

Library: wxPropertyGrid
Category: wxPropertyGrid, Events

## Public Member Functions
| wxPropertyGridEvent (wxEventType commandType=0, int id=0)
| Constructor. More...
| wxPropertyGridEvent (const wxPropertyGridEvent &event)
| Copy constructor. More...
| ~wxPropertyGridEvent ()
| Destructor. More...
bool | CanVeto () const
| Returns true if you can veto the action that the event is signalling. More...
unsigned int | GetColumn () const
| Returns the column index associated with this event. More...
wxPGProperty * | GetMainParent () const
| Returns highest level non-category, non-root parent of property for which event occurred. More...
wxPGProperty * | GetProperty () const
| Returns property associated with this event. More...
wxPGVFBFlags | GetValidationFailureBehavior () const
| Returns current validation failure flags. More...
wxString | GetPropertyName () const
| Returns name of the associated property. More...
wxVariant | GetPropertyValue () const
| Returns value of the associated property. More...
wxVariant | GetValue () const
| Returns value of the associated property. More...
void | SetCanVeto (bool canVeto)
| Set if event can be vetoed. More...
void | SetProperty (wxPGProperty *p)
| Changes the property associated with this event. More...
void | SetValidationFailureBehavior (wxPGVFBFlags flags)
| Set override validation failure behaviour. More...
void | SetValidationFailureMessage (const wxString &message)
| Sets custom failure message for this time only. More...
void | Veto (bool veto=true)
| Call this from your event handler to veto action that the event is signalling. More...
bool | WasVetoed () const
| Returns true if event was vetoed. More...
Public Member Functions inherited from wxCommandEvent
| wxCommandEvent (wxEventType commandEventType=wxEVT_NULL, int id=0)
| Constructor. More...
void * | GetClientData () const
| Returns client data pointer for a listbox or choice selection event (not valid for a deselection). More...
wxClientData * | GetClientObject () const
| Returns client object pointer for a listbox or choice selection event (not valid for a deselection). More...
long | GetExtraLong () const
| Returns extra information dependent on the event objects type. More...
int | GetInt () const
| Returns the integer identifier corresponding to a listbox, choice or radiobox selection (only if the event was a selection, not a deselection), or a boolean value representing the value of a checkbox. More...
int | GetSelection () const
| Returns item index for a listbox or choice selection event (not valid for a deselection). More...
wxString | GetString () const
| Returns item string for a listbox or choice selection event. More...
bool | IsChecked () const
| This method can be used with checkbox and menu events: for the checkboxes, the method returns true for a selection event and false for a deselection one. More...
bool | IsSelection () const
| For a listbox or similar event, returns true if it is a selection, false if it is a deselection. More...
void | SetClientData (void *clientData)
| Sets the client data for this event. More...
void | SetClientObject (wxClientData *clientObject)
| Sets the client object for this event. More...
void | SetExtraLong (long extraLong)
| Sets the m_extraLong member. More...
void | SetInt (int intCommand)
| Sets the m_commandInt member. More...
void | SetString (const wxString &string)
| Sets the m_commandString member. More...
Public Member Functions inherited from wxEvent
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor. More...
virtual wxEvent * | Clone () const =0
| Returns a copy of the event. More...
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any. More...
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_BUTTON`. More...
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event. More...
int | GetId () const
| Returns the identifier associated with this event, such as a button command id. More...
wxObject * | GetEventUserData () const
| Return the user data associated with a dynamically connected event handler. More...
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise. More...
long | GetTimestamp () const
| Gets the timestamp for the event. More...
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false. More...
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation). More...
void | SetEventObject (wxObject *object)
| Sets the originating object. More...
void | SetEventType (wxEventType type)
| Sets the event type. More...
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id. More...
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event. More...
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0. More...
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns. More...
int | StopPropagation ()
| Stop the event from propagating to its parent window. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to nullptr the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=nullptr, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxEvent
int | m_propagationLevel
| Indicates how many levels the event can propagate. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxPropertyGridEvent() [1/2]

wxPropertyGridEvent::wxPropertyGridEvent | ( | wxEventType | commandType = `0`,
|  | int | id = `0`
| ) |  |

Constructor.

## ◆ wxPropertyGridEvent() [2/2]

wxPropertyGridEvent::wxPropertyGridEvent | ( | const wxPropertyGridEvent & | event | ) |

Copy constructor.

## ◆ ~wxPropertyGridEvent()

wxPropertyGridEvent::~wxPropertyGridEvent | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ CanVeto()

bool wxPropertyGridEvent::CanVeto | ( |  | ) | const

Returns true if you can veto the action that the event is signalling.

## ◆ GetColumn()

unsigned int wxPropertyGridEvent::GetColumn | ( |  | ) | const

Returns the column index associated with this event.

For the column dragging events, it is the column to the left of the splitter being dragged

## ◆ GetMainParent()

wxPGProperty* wxPropertyGridEvent::GetMainParent | ( |  | ) | const

Returns highest level non-category, non-root parent of property for which event occurred.

Useful when you have nested properties with children.

Remarks
  If immediate parent is root or category, this will return the property itself.

## ◆ GetProperty()

wxPGProperty* wxPropertyGridEvent::GetProperty | ( |  | ) | const

Returns property associated with this event.

Remarks
  You should assume that this property can always be nullptr. For instance, `wxEVT_PG_SELECTED` is emitted not only when a new property is selected, but also when selection is cleared by user activity.

## ◆ GetPropertyName()

wxString wxPropertyGridEvent::GetPropertyName | ( |  | ) | const

Returns name of the associated property.

Remarks
  Property name is stored in event, so it remains accessible even after the associated property or the property grid has been deleted.

## ◆ GetPropertyValue()

wxVariant wxPropertyGridEvent::GetPropertyValue | ( |  | ) | const

Returns value of the associated property.

Works for all event types, but for `wxEVT_PG_CHANGING` this member function returns the value that is pending, so you can call Veto() if the value is not satisfactory.

Remarks
  Property value is stored in event, so it remains accessible even after the associated property or the property grid has been deleted.

## ◆ GetValidationFailureBehavior()

wxPGVFBFlags wxPropertyGridEvent::GetValidationFailureBehavior | ( |  | ) | const

Returns current validation failure flags.

## ◆ GetValue()

wxVariant wxPropertyGridEvent::GetValue | ( |  | ) | const

Returns value of the associated property.

See also
  GetPropertyValue()

## ◆ SetCanVeto()

void wxPropertyGridEvent::SetCanVeto | ( | bool | canVeto | ) |

Set if event can be vetoed.

## ◆ SetProperty()

void wxPropertyGridEvent::SetProperty | ( | wxPGProperty * | p | ) |

Changes the property associated with this event.

## ◆ SetValidationFailureBehavior()

void wxPropertyGridEvent::SetValidationFailureBehavior | ( | wxPGVFBFlags | flags | ) |

Set override validation failure behaviour.

Only effective if Veto() was also called, and only allowed if event type is `wxEVT_PG_CHANGING`.

## ◆ SetValidationFailureMessage()

void wxPropertyGridEvent::SetValidationFailureMessage | ( | const wxString & | message | ) |

Sets custom failure message for this time only.

Only applies if wxPGVFBFlags::ShowMessage is set in validation failure flags.

## ◆ Veto()

void wxPropertyGridEvent::Veto | ( | bool | veto = `true` | ) |

Call this from your event handler to veto action that the event is signalling.

You can only veto a shutdown if wxPropertyGridEvent::CanVeto() returns true.

Remarks
  Currently only `wxEVT_PG_CHANGING` supports vetoing.

## ◆ WasVetoed()

bool wxPropertyGridEvent::WasVetoed | ( |  | ) | const

Returns true if event was vetoed.